#!/bin/sh
 
[ $# -ne 1 ] && echo >&2 "Usage : $0 <mailbox>" && exit 1
Mailbox=$1

awk 'BEGIN {flag = 0} \
#
# Cherche en-tete de mel
#
flag == 0 { /^From / && flag = 1 ; } \
#
# Cherche ligne From:
#
flag == 1 { $0 ~ /From:/ && flag = 2 } \
#
# Cherche mot contenant @
#
flag == 2 { \
    for (i = 1 ; i <= NF ; i++) { \
    $i ~ /<.*@.*>/ && sub ("<", "", $i) && sub (">", "", $i) ; \
    $i ~ /@/ && liste[$i]++ ; \
    } \
    flag = 0 \
} \
END {for (email in liste) print liste[email], email }' $Mailbox | \
sort -rn | awk '{ print FNR, $0 }'
